package yrpg.fi.fibd.plugin.other;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.api.result.ApiSaveItemData;
import kd.bos.openapi.api.result.ApiSaveResult;
import kd.bos.openapi.api.result.ApiSaveRowErrorData;
import kd.bos.openapi.api.result.BaseFilterItemData;
import kd.bos.openapi.api.result.BaseFilterResult;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class ApiResponseUtil {

    public static void assembleResult(ApiSaveResult data, BaseFilterResult responseData, boolean responseNotnull,List<Map<String, Object>> resultList){
        //保存接口设置回参
        List<ApiSaveItemData> result = data.getResult();
        for(ApiSaveItemData item:result){
            Map<String, Object> resultMap = new HashMap<>();
            resultMap.put("busiDataId",item.getId());
            resultMap.put("mdmCode",item.getKeys().get("yrpg_key"));
            resultMap.put("success",item.isBillStatus());
            if (!item.isBillStatus()){
                //组装错误信息
                List<ApiSaveRowErrorData> errors = item.getErrors();
                List<String> curerrors = new ArrayList<String>();
                for(ApiSaveRowErrorData errer:errors){
                    //明细错误拼接
                    StringBuffer sb = new StringBuffer();
                    Set<String> rowMsg = errer.getRowMsg();
                    for(String err:rowMsg){
                        sb = sb.append(err);
                    }
                    curerrors.add(sb.toString());
                }
                resultMap.put("message",curerrors.toString());
            }else {
                resultMap.put("message","该条数据成功！");

            }
            resultList.add(resultMap);
        }

    }

    public static void freezeResult(BaseFilterResult data,Map<String,String> accountViewNumMap,List<Map<String, Object>> resultList){
        List<BaseFilterItemData> result = data.getResult();
        for(BaseFilterItemData item : result){
            Map<String, Object> resultMap = new HashMap<>();
            resultMap.put("busiDataId",item.getId());
            resultMap.put("mdmCode",accountViewNumMap.get(item.getNumber()));
            resultMap.put("success",item.isBillStatus());
            if (!item.isBillStatus()){
                resultMap.put("message",item.getErrors().toString());
            }else {
                resultMap.put("message","该条数据成功！");
            }
            resultList.add(resultMap);
        }


    }

    public static void newFreezeResult(JSONArray newfreezeData,List<Map<String, Object>> resultList){
        //将新增封存数据拼入返回值
        for(int i=0;i<newfreezeData.size();i++){
            JSONObject item = newfreezeData.getJSONObject(i);
            Map<String, Object> resultMap = new HashMap<>();
            resultMap.put("busiDataId","");
            resultMap.put("mdmCode",item.getString("yrpg_key"));
            resultMap.put("success",true);
            resultMap.put("message","该条数据为新增禁用，自动忽略！");

            resultList.add(resultMap);


        }
    }


}
